

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   CaseMod Plugin Pack 1.02                                      *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2004-09-16   *
    *                                                                 *
    *   ___________________________________________________________   *
    *                                                                 *
    *   Big thanks to Werner von Wolfpassing for converting the       *
	*   Weaverslave SDK from Delphi to C.                             *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#ifndef COMPILE_CAPITALIZE
#ifndef COMPILE_LOWERCASE
#ifndef COMPILE_UPPERCASE
#error "One of these must be defined: COMPILE_CAPITALIZE, COMPILE_LOWERCASE, COMPILE_UPPERCASE"
#else
#pragma message( " -- UPPERCASE compilation --" )
#endif	// COMPILE_UPPERCASE
#else
#pragma message( " -- LOWERCASE compilation --" )
#endif	// COMPILE_LOWERCASE
#else
#pragma message( " -- CAPITALIZE compilation --" )
#endif	// COMPILE_CAPITALIZE


#pragma comment( linker, "/nodefaultlib:\"LIBCMT.LIB\" /ignore:4089" )
#include "devil_compile.h"

#include "ws_plugin.h"


/*
#ifdef COMPILE_CAPITALIZE
#include "res_cap.h"
#else
#ifdef COMPILE_LOWERCASE
#include "res_low.h"
#else
#ifdef COMPILE_UPPERCASE
#include "res_upp.h"
#endif	// COMPILE_UPPERCASE
#endif	// COMPILE_LOWERCASE
#endif	// COMPILE_CAPITALIZE
*/


HINSTANCE g_hInstance;



/******************************************************************************************************
**  DllMain                                                                                          **
******************************************************************************************************/

BOOL APIENTRY DllMain( HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	g_hInstance = ( HINSTANCE )hModule;
	return TRUE;
}


/******************************************************************************************************
**  convert_in_place                                                                                 **
******************************************************************************************************/

void convert_in_place( char * source )
{
	#ifdef COMPILE_CAPITALIZE

		bool bCapNext = true;
		while( *source != '\0' )
		{
			if( ( *source >= 'a' ) && ( *source <= 'z' ) )
			{
				if( bCapNext )
				{
					bCapNext = false;
					*source = *source - 32;
				}
			}
			else if( ( *source == '\'' ) || ( ( *source >= 'A' ) && ( *source <= 'Z' ) ) )
			{
				bCapNext = false;
			}
			else
			{
				bCapNext = true;
			}

			source++;
		}

	#else
	#ifdef COMPILE_LOWERCASE

		_strlwr( source );

	#else
	#ifdef COMPILE_UPPERCASE

		_strupr( source );

	#endif	// COMPILE_UPPERCASE
	#endif	// COMPILE_LOWERCASE
	#endif	// COMPILE_CAPITALIZE
}


/******************************************************************************************************
**  Start_Plugin                                                                                     **
******************************************************************************************************/

int __stdcall Start_Plugin( int hwnd,	// Handle of Mainform
                            int sys,	// Handle of pluginsystem component
                            int cb		// Callback function
                          )
{
	SetCallBack( cb, sys );
	int res;

	if( Callback_GetSelLength( &res ) )
	{
		// Process selection only
		char * source = Callback_GetSelText( &res );
		convert_in_place( source );
		Callback_SetSelText( source, &res );
	}
	else
	{
		// Process whole file
		char * source = Callback_GetText( &res );
		convert_in_place( source );
		Callback_SetText( source, &res );
	}

	return 0;
}


/******************************************************************************************************
**  Init_InterfaceVersion                                                                            **
******************************************************************************************************/

int __stdcall Init_InterfaceVersion( void )
{
	return 3;
}


/******************************************************************************************************
**  pluginInfo                                                                                       **
******************************************************************************************************/

char * __stdcall pluginInfo( int ask )
{
	switch( ask )
    {
		case srp_Info_Title:
		{
			#ifdef COMPILE_CAPITALIZE

				return "Capitalize";
			
			#else
			#ifdef COMPILE_LOWERCASE

				return "Lowercase";

			#else
			#ifdef COMPILE_UPPERCASE

				return "Uppercase";

			#endif	// COMPILE_UPPERCASE
			#endif	// COMPILE_LOWERCASE
			#endif	// COMPILE_CAPITALIZE
			
		}
		case srp_Info_Group         : return "Hartwork Project";
		case srp_Info_Version       : return "1.02";
		case srp_Info_Description:
		{
			#ifdef COMPILE_CAPITALIZE

				return "Convert to Capitalized";
			
			#else
			#ifdef COMPILE_LOWERCASE

				return "Convert to Lowercase";

			#else
			#ifdef COMPILE_UPPERCASE

				return "Convert to Uppercase";

			#endif	// COMPILE_UPPERCASE
			#endif	// COMPILE_LOWERCASE
			#endif	// COMPILE_CAPITALIZE
			
		}
		case srp_Info_Licence       : return "LGPL";
		case srp_Info_Copyright     : return " 2004 Sebastian Pipping <webmaster@hartwork.org>";
    }
	return ""; 
}
